diff -urpN --exclude-from=/home/davej/.exclude bk-linus/sound/oss/cs4232.c linux-2.5/sound/oss/cs4232.c
--- bk-linus/sound/oss/cs4232.c	2002-11-21 02:26:03.000000000 +0000
+++ linux-2.5/sound/oss/cs4232.c	2002-11-21 18:06:16.000000000 +0000
@@ -382,10 +420,11 @@ static int cs4232_pnp_probe(struct pnp_d
 	isapnpcfg->io_base	= dev->resource[0].start;
 	if (probe_cs4232(isapnpcfg,TRUE) == 0) {
 		printk(KERN_ERR "cs4232: ISA PnP card found, but not detected?\n");
+		kfree(isapnpcfg);
 		return -ENODEV;
 	}
 	attach_cs4232(isapnpcfg);
-	dev->driver_data = isapnpcfg;
+	pci_set_drvdata(dev,isapnpcfg);
 	return 0;
 }
 
